#pragma once

#include "LatexSymbols.h"

#include <string>
#include <memory>
#include <vector>

class LatexMathExpression
{
public:
	LatexMathExpression(const std::string& expression = {})
		: mRawExpression(expression)
	{

	}

	void parse()
	{
		for (auto c : mRawExpression)
		{

		}
	}

	const std::vector<LatexMathSymbol>& getSymbols() const
	{
		return mSymbols;
	}

private:

	unsigned mOpenTagCount{ 0 };

	std::string mRawExpression;
	std::unique_ptr<LatexMathExpression> mSuperScriptExpr;
	std::unique_ptr<LatexMathExpression> mSubScriptExpr;
	std::unique_ptr<LatexMathExpression> mEnclosedExpr;

	std::vector<LatexMathSymbol> mSymbols;
};